package com.steerinfo.dil.controller;


import com.steerinfo.dil.model.QmsQueueResult;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.dil.service.IQmsQueueResultService;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import java.util.*;

/**
 * QmsQueueResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-14 11:27
 * 类描述
 * 修订历史：
 * 日期：2021-09-14
 * 作者：generator
 * 参考：
 * 描述：QmsQueueResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/qmsqueueresults")
public class QmsQueueResultController extends BaseRESTfulController {

    @Autowired
    IQmsQueueResultService qmsQueueResultService;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="触发电子围栏-->新增排队实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "", required = false, dataType = "Map"),
    })
    @PostMapping("/addQueueResult")
    public RESTfulResult addQueueResult(String orderNumber){
        Map<String, Object> mapValue = new HashMap<>();
        mapValue.put("orderNumber", orderNumber);
        int i = qmsQueueResultService.addQueueResult(mapValue);
        return success(i);
    }

    @ApiOperation(value="查询排队申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(125)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueApply")
    public RESTfulResult getQueueApply(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allQueueApply = qmsQueueResultService.getQueueApply(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueApply = qmsQueueResultService.getQueueApply(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueApply,queueApply);
        return success(pageList);
    }

    @ApiOperation(value="查询执行中订单")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(156)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllExecutionOrder")
    public RESTfulResult getAllExecutionOrder(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize,
                                       Integer orderType,
                                       Integer status
    ){
        if(mapValue == null){
            mapValue = new HashMap<>();
        }
        mapValue.put("orderTypee", orderType);
        mapValue.put("orderStatus", status);

        //不分页筛选数据
        List<Map<String, Object>> AllExecutionOrder = qmsQueueResultService.getAllExecutionOrder(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> executionOrder = qmsQueueResultService.getAllExecutionOrder(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, AllExecutionOrder,executionOrder);
        return success(pageList);
    }


    @ApiOperation(value="指令接收")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(130)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/orderReceive")
    public RESTfulResult orderReceive(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allOrderReceive = qmsQueueResultService.orderReceive(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> orderReceive = qmsQueueResultService.orderReceive(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allOrderReceive,orderReceive);
        return success(pageList);
    }

    @ApiOperation(value="查询排队开始")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(128)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueListByQueueUp")
    public RESTfulResult getQueueListByQueueUp(@RequestBody(required=false) Map<String,Object> mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize,
                                       Integer gridId
    ){
        if(mapValue == null){
            mapValue = new HashMap<>();
        }
        if(gridId != null){
            mapValue.put("gridId", gridId);
        }
        //不分页筛选数据
        List<Map<String, Object>> allQueueApply = qmsQueueResultService.getQueueListByQueueUp(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueApply = qmsQueueResultService.getQueueListByQueueUp(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueApply,queueApply);
        return success(pageList);
    }

    @ApiOperation(value="查询排队转移")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(124)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getChangeQueue")
    public RESTfulResult getChangeQueue(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allChangeQueueMes = qmsQueueResultService.getChangeQueueMes(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> changeQueueMes = qmsQueueResultService.getChangeQueueMes(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allChangeQueueMes,changeQueueMes);
        return success(pageList);
    }

    @ApiOperation(value="查询排队取消")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(131)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueCancel")
    public RESTfulResult getQueueCancel(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allQueueCancel = qmsQueueResultService.getQueueCancel(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueCancel = qmsQueueResultService.getQueueCancel(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueCancel,queueCancel);
        return success(pageList);
    }

    @ApiOperation(value="通过Id查询排队取消实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "", required = false, dataType = "Map"),
    })
    @PostMapping("/getQueueCancelByResultId/{resultId}")
    public RESTfulResult getQueueCancelByResultId(@PathVariable("resultId") Integer resultId){
        List<Map<String, Object>> mes = qmsQueueResultService.getQueueCancelByResultId(resultId);
        return success(mes);
    }

    @ApiOperation(value="修改排队取消实绩：时间、原因")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "", required = false, dataType = "Map"),
    })
    @PostMapping("/updateQueueCancel")
    public RESTfulResult updateQueueCancel(@RequestBody QmsQueueResult qmsQueueResult){
        int i = qmsQueueResultService.updateQueueCancel(qmsQueueResult);
        return success(i);
    }

    @ApiOperation(value="查询排队插队")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(132)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueInsert")
    public RESTfulResult getQueueInsert(@RequestBody(required=false) Map<String,Object> mapValue,
                                        Integer apiId,
                                        Integer pageNum,
                                        Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allInsetResult = qmsQueueResultService.getQueueInsert(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> insertResult = qmsQueueResultService.getQueueInsert(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allInsetResult,insertResult);
        return success(pageList);
    }

    @ApiOperation(value="查询排队结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(133)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQueueEndResult")
    public RESTfulResult getQueueEndResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                              Integer apiId,
                                              Integer pageNum,
                                              Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allQueueEndResult = qmsQueueResultService.getQueueEndResult(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> queueEndResult = qmsQueueResultService.getQueueEndResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQueueEndResult,queueEndResult);
        return success(pageList);
    }

    @ApiOperation(value="汽车监控")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(135)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/capacityMonitor")
    public RESTfulResult capacityMonitor(@RequestBody(required=false) Map<String,Object> mapValue,
                                           Integer apiId,
                                           Integer pageNum,
                                           Integer pageSize
    ){
        //不分页筛选数据
        List<Map<String, Object>> allCapacityMonitor = qmsQueueResultService.capacityMonitor(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> capacityMonitor = qmsQueueResultService.capacityMonitor(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allCapacityMonitor,capacityMonitor);
        return success(pageList);
    }


    @ApiOperation(value="查询各仓库，门岗的排队状态列表")
    @PostMapping("/getQueueStatusList")
    public RESTfulResult getQueueStatusList(){
        List<Map<String, Object>> queueStatusList = qmsQueueResultService.getQueueStatusList();
        return success(queueStatusList);
    }

    @ApiOperation(value="通过车牌号查询司机接收排队信息")
    @PostMapping("/getOrderReceive/{capacityNumber}")
    public RESTfulResult getOrderReceive(@PathVariable("capacityNumber") String capacityNumber){
        List<Map<String, Object>> orderReceiveMap = qmsQueueResultService.getOrderReceive2(capacityNumber);
        return success(orderReceiveMap);
    }

    @ApiOperation(value="通过车牌号取消排队")
    @PostMapping("/cancelQueue")
    public RESTfulResult cancelQueue(@RequestBody Map<String,Object> mapValue){
        int code = qmsQueueResultService.cancelQueue(mapValue);
        return success(code);
    }
}
