package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.QmsQueueList;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;

@Mapper
public interface QmsQueueListMapper extends IBaseMapper<QmsQueueList, BigDecimal> {
    //查询主键MaxId
    BigDecimal selectMaxId();

    //查询当前链表最大序号
    Integer getMaxListNodeOrder(Map<String, Object> map);

    //通过运输订单号 或实绩Id 关联 实绩总表 查询 排队实绩
    Map<String, Object> getQueueResultByOrderNumber(Map<String, Object> map);

    //通过链表ID 查询当前网格id
    BigDecimal getGridIdByListId(BigDecimal listId);

    //通过链表Id查询当前网格中所有的排队车数 以及最小的顺序号
    Map<String, Object> getQueueNumAndMin(BigDecimal gridId);

    //链表监控
    List<Map<String, Object>> listMonitor(Map<String, Object> map);

}